export interface WafuOptions<T = any> {
    caseSensitive: boolean;
    shouldSort: boolean;
    getFn: (obj: T, path: string) => string | string[];
    keys: Array<string | {
        name: string;
        weight: number;
    }>;
    tokenize: boolean;
    tokenSeparator: Parameters<String["split"]>[0];
    matchAllTokens: boolean;
    location: number;
    distance: number;
    threshold: number;
    includeMatches: boolean;
    minMatchCharLength: number;
}
export interface WafuResult<T> {
    item: T;
    score: number;
    matches?: WafuMatch[];
}
export interface WafuMatch {
    indices: Array<[number, number]>;
    value: string;
    key?: string;
    arrayIndex?: number;
}
export interface SearchOpts {
    limit?: number;
}
export declare const defaultOptions: Readonly<WafuOptions>;
export declare class Wafu<T> {
    private collection;
    private options;
    private fields;
    private rsFields;
    private rsOptions;
    constructor(collection: T[], opts?: Partial<WafuOptions<T>>);
    search(pattern: string, opts?: SearchOpts): WafuResult<T>[];
}
